/*
//  NUScope 2012 BME305 EMG Game
// Nick Marchuk
// 11/25/2012
//
*/

import guicomponents.*;

// NUScope USB
NUScopeCommand ToPic;
int PowerUsage = 0;
int powerBar = 0;
int DCount = 0;
int DFreq = 0;
int[] dataA = new int[5000];
int[] dataB = new int[5000];
int[] dataD1 = new int[5000];
int[] dataD2 = new int[5000];
int[] dataD3 = new int[5000];
int[] dataD4 = new int[5000];
int dataIndex = 0;
int goTo = 0;
int CallAquire = 0;
int frame;
int readyToAsk = 0;
int stopAfterNextFill = 0;
long lastPacketTime = 0;

int score = 0;

PImage wildcat;
PFont font;
Boolean save_image = false;
Boolean saveData1 = false;
Boolean saveData2 = false;

int ii;

// NUScope data
int i;
int MAXDATALEN = 5000;
int dataPos;
Boolean sampling = false;

int posY1 = 0;
int posY2 = 0;

///////////////////////////////////////////////////////////////////////////
// pong parts
///////////////////////////////////////////////////////////////////////////
// Global variables for the ball
float pvoltage1 = 0;
float ball_x;
float ball_y;
float ball_dir = 1;
float ball_size = 25;  // Radius
float dy = 0;  // Direction

// Global variables for the paddle
int paddle_width = 10;
int paddle_height = 60;

int dist_wall = 15;

void setup() {
  size(700, 650);
  
  sendData = 1;
  frame = 0;

  ToPic = new NUScopeCommand(1, // PowerOn (0-1)
                             0, // SensA (0-7)
                             0, // SensB (0-7)
                             1, // NumDataPoints
                             5333, // SampleRate
                             0, //FnType
                             0, // FnFreq
                             0, // DigType 
                             0, // DigFreq
                             0, // TrigType
                             0 // TrigLevel
                             );

  openPic(0);
  
  // zero the data
  for (i=0;i<MAXDATALEN;i++) {
    dataA[i] = 0;
    dataB[i] = 0;
    dataD1[i] = 0;
    dataD2[i] = 0;
    dataD3[i] = 0;
    dataD4[i] = 0;
  } 
  dataPos = 0;
  
  wildcat = loadImage("wildcat_med.gif");
  font = loadFont("Verdana-BoldItalic-38.vlw");
  
  // pong parts
  rectMode(RADIUS);
  ellipseMode(RADIUS);
  noStroke();
  smooth();
  ball_y = height/2;
  ball_x = 1;
}

void draw() {
  
  background(255);
  
  image(wildcat, 60, 50); //x,y,w,h
  textFont(font);
  text("UScope EMG PONG!",142,170);
  text("Score:",142,210);
  text(score,280,210);
  
  //frame++;
  //if (frame > 30 && readyToAsk == 1) { 
  //  frame = 0;
    //sendData = 1;
    //readyToAsk = 0;
   // fill(255,0,0);
    
    //saveData1 = true;
    //readyToAsk = 1;
  //}
  //else {
  //  fill(0,255,0);
  //}
  //ellipse(650,90,35,35);
  //fill(255);
  
  ///////////////////////////////////////////////////////////////////////////
  // pong parts
  ///////////////////////////////////////////////////////////////////////////  
  ball_x += ball_dir * 3.0;
  ball_y += dy;
  if(ball_x > width+ball_size) {
    ball_x = -width/2 - ball_size;
    ball_y = random(0, height);
    dy = 0;
    // subtract score
    score-=20;
  }
  
  //print(ball_x);
  //print(" ");
  //println(ball_y);
  
  // Constrain paddle to screen
  float voltage1 = map(posY1, 1023,512,0,height);
  float paddle_y = constrain(voltage1, paddle_height, height-paddle_height);
  
  //print(posY1);
  //print(" ");
  //print(voltage1);
  //print(" ");
  //println(paddle_y);

  // Test to see if the ball is touching the paddle
  float py = width-dist_wall-paddle_width-ball_size;
  if(ball_x+3 >= py && ball_x < py+3  
     && ball_y > paddle_y - paddle_height - ball_size 
     && ball_y < paddle_y + paddle_height + ball_size) {
    ball_dir *= -1;
    if(voltage1 != pvoltage1) {
      dy = (voltage1-pvoltage1)/2.0;
      if(dy >  5) { dy =  5; }
      if(dy < -5) { dy = -5; }
    }
    // increment score
    score+=5;
  } 
  
  //print(ball_dir);
  //print(" ");
  //println(dy);
  
  // If ball hits paddle or back wall, reverse direction
  if(ball_x < ball_size && ball_dir == -1) {
    ball_dir *= -1;
  }
  
  // If the ball is touching top or bottom edge, reverse direction
  if(ball_y > height-ball_size) {
    dy = dy * -1;
  }
  if(ball_y < ball_size) {
    dy = dy * -1;
  }

  // Draw ball
  fill(136,18,201);
  ellipse(ball_x, ball_y, ball_size, ball_size);
  
  // Draw the paddle
  fill(153);
  rect(width-dist_wall, paddle_y, paddle_width, paddle_height);  
  pvoltage1 = voltage1;
  
  //draw scope trace
  arrayCopy(dataA,1,dataA,0,width-1); //src, srcPosition, dst, dstPosition, length
  dataA[width-1] = int(paddle_y);
  
  fill(0);
  for(i=0;i<width;i++) {
    ellipse(i,dataA[i],1,1);
  }
  
  fill(128);
} // end draw

//////////////////////////////////////////////
// Classes
//////////////////////////////////////////////
class NUScopeCommand {
  int PowerOn;
  int SensA;
  int SensB;
  int NumDataPoints;
  int gotNumDataPoints;
  int SampleRate;
  int FnType;
  int FnFreq;
  int DigType;
  int DigFreq;
  int TrigType;
  int TrigLevel;

  NUScopeCommand(int iPowerOn, int iSensA, int iSensB, int iNumDataPoints, int iSampleRate, int iFnType, int iFnFreq, int iDigType, int iDigFreq, int iTrigType, int iTrigLevel) {
    PowerOn = iPowerOn;
    
    SensA = iSensA;
    SensB = iSensB;
    NumDataPoints = iNumDataPoints;
    gotNumDataPoints = 0;
    SampleRate = iSampleRate;
    FnType = iFnType;
    FnFreq = iFnFreq;
    DigType = iDigType;
    DigFreq = iDigFreq;
    TrigType = iTrigType;
    TrigLevel = iTrigLevel;
  }
}

