import processing.core.*; 
import processing.xml.*; 

import guicomponents.*; 
import com.codeminders.hidapi.*; 

import com.codeminders.hidapi.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class NuScope3_5_pong extends PApplet {

/*
//  NUScope 2012 BME305 EMG Game
// Nick Marchuk
// 11/25/2012
//
*/



// NUScope USB
NUScopeCommand ToPic;
int PowerUsage = 0;
int powerBar = 0;
int DCount = 0;
int DFreq = 0;
int[] dataA = new int[5000];
int[] dataB = new int[5000];
int[] dataD1 = new int[5000];
int[] dataD2 = new int[5000];
int[] dataD3 = new int[5000];
int[] dataD4 = new int[5000];
int dataIndex = 0;
int goTo = 0;
int CallAquire = 0;
int frame;
int readyToAsk = 0;
int stopAfterNextFill = 0;
long lastPacketTime = 0;

int score = 0;

PImage wildcat;
PFont font;
Boolean save_image = false;
Boolean saveData1 = false;
Boolean saveData2 = false;

int ii;

// NUScope data
int i;
int MAXDATALEN = 5000;
int dataPos;
Boolean sampling = false;

int posY1 = 0;
int posY2 = 0;

///////////////////////////////////////////////////////////////////////////
// pong parts
///////////////////////////////////////////////////////////////////////////
// Global variables for the ball
float pvoltage1 = 0;
float ball_x;
float ball_y;
float ball_dir = 1;
float ball_size = 25;  // Radius
float dy = 0;  // Direction

// Global variables for the paddle
int paddle_width = 10;
int paddle_height = 60;

int dist_wall = 15;

public void setup() {
  size(700, 650);
  
  sendData = 1;
  frame = 0;

  ToPic = new NUScopeCommand(1, // PowerOn (0-1)
                             0, // SensA (0-7)
                             0, // SensB (0-7)
                             1, // NumDataPoints
                             5333, // SampleRate
                             0, //FnType
                             0, // FnFreq
                             0, // DigType 
                             0, // DigFreq
                             0, // TrigType
                             0 // TrigLevel
                             );

  openPic(0);
  
  // zero the data
  for (i=0;i<MAXDATALEN;i++) {
    dataA[i] = 0;
    dataB[i] = 0;
    dataD1[i] = 0;
    dataD2[i] = 0;
    dataD3[i] = 0;
    dataD4[i] = 0;
  } 
  dataPos = 0;
  
  wildcat = loadImage("wildcat_med.gif");
  font = loadFont("Verdana-BoldItalic-38.vlw");
  
  // pong parts
  rectMode(RADIUS);
  ellipseMode(RADIUS);
  noStroke();
  smooth();
  ball_y = height/2;
  ball_x = 1;
}

public void draw() {
  
  background(255);
  
  image(wildcat, 60, 50); //x,y,w,h
  textFont(font);
  text("UScope EMG PONG!",142,170);
  text("Score:",142,210);
  text(score,280,210);
  
  //frame++;
  //if (frame > 30 && readyToAsk == 1) { 
  //  frame = 0;
    //sendData = 1;
    //readyToAsk = 0;
   // fill(255,0,0);
    
    //saveData1 = true;
    //readyToAsk = 1;
  //}
  //else {
  //  fill(0,255,0);
  //}
  //ellipse(650,90,35,35);
  //fill(255);
  
  ///////////////////////////////////////////////////////////////////////////
  // pong parts
  ///////////////////////////////////////////////////////////////////////////  
  ball_x += ball_dir * 3.0f;
  ball_y += dy;
  if(ball_x > width+ball_size) {
    ball_x = -width/2 - ball_size;
    ball_y = random(0, height);
    dy = 0;
    // subtract score
    score-=20;
  }
  
  //print(ball_x);
  //print(" ");
  //println(ball_y);
  
  // Constrain paddle to screen
  float voltage1 = map(posY1, 1023,512,0,height);
  float paddle_y = constrain(voltage1, paddle_height, height-paddle_height);
  
  //print(posY1);
  //print(" ");
  //print(voltage1);
  //print(" ");
  //println(paddle_y);

  // Test to see if the ball is touching the paddle
  float py = width-dist_wall-paddle_width-ball_size;
  if(ball_x+3 >= py && ball_x < py+3  
     && ball_y > paddle_y - paddle_height - ball_size 
     && ball_y < paddle_y + paddle_height + ball_size) {
    ball_dir *= -1;
    if(voltage1 != pvoltage1) {
      dy = (voltage1-pvoltage1)/2.0f;
      if(dy >  5) { dy =  5; }
      if(dy < -5) { dy = -5; }
    }
    // increment score
    score+=5;
  } 
  
  //print(ball_dir);
  //print(" ");
  //println(dy);
  
  // If ball hits paddle or back wall, reverse direction
  if(ball_x < ball_size && ball_dir == -1) {
    ball_dir *= -1;
  }
  
  // If the ball is touching top or bottom edge, reverse direction
  if(ball_y > height-ball_size) {
    dy = dy * -1;
  }
  if(ball_y < ball_size) {
    dy = dy * -1;
  }

  // Draw ball
  fill(136,18,201);
  ellipse(ball_x, ball_y, ball_size, ball_size);
  
  // Draw the paddle
  fill(153);
  rect(width-dist_wall, paddle_y, paddle_width, paddle_height);  
  pvoltage1 = voltage1;
  
  //draw scope trace
  arrayCopy(dataA,1,dataA,0,width-1); //src, srcPosition, dst, dstPosition, length
  dataA[width-1] = PApplet.parseInt(paddle_y);
  
  fill(0);
  for(i=0;i<width;i++) {
    ellipse(i,dataA[i],1,1);
  }
  
  fill(128);
} // end draw

//////////////////////////////////////////////
// Classes
//////////////////////////////////////////////
class NUScopeCommand {
  int PowerOn;
  int SensA;
  int SensB;
  int NumDataPoints;
  int gotNumDataPoints;
  int SampleRate;
  int FnType;
  int FnFreq;
  int DigType;
  int DigFreq;
  int TrigType;
  int TrigLevel;

  NUScopeCommand(int iPowerOn, int iSensA, int iSensB, int iNumDataPoints, int iSampleRate, int iFnType, int iFnFreq, int iDigType, int iDigFreq, int iTrigType, int iTrigLevel) {
    PowerOn = iPowerOn;
    
    SensA = iSensA;
    SensB = iSensB;
    NumDataPoints = iNumDataPoints;
    gotNumDataPoints = 0;
    SampleRate = iSampleRate;
    FnType = iFnType;
    FnFreq = iFnFreq;
    DigType = iDigType;
    DigFreq = iDigFreq;
    TrigType = iTrigType;
    TrigLevel = iTrigLevel;
  }
}

public final boolean DEBUG = true;



// HID manager and device
HIDManager mgr;
HIDDeviceInfo[] devs;
HIDDevice pic;
boolean picConnected = false;
String picPath = "";

// openPic takes in the desired productID of the pic you wish to open
public void openPic(int picNo)
{
  ClassPathLibraryLoader.loadNativeHIDLibrary();
  
  // Create instances of HIDManager, and USBListener
  try {
    mgr = HIDManager.getInstance();
  } 
 catch (Exception e) {
    e.printStackTrace();
    if (DEBUG)println("Failed to create HIDManager");
  }
  usbEvent = new USBListener();


  println("Attempting to Connect to PIC #"+picNo+"...");
  while (!picConnected) {
    try {
      // Dump a list of all connected HID devices into devs
      devs = mgr.listDevices();
    } 
    catch (Exception e) {
      e.printStackTrace();
      if (DEBUG)println("Cannot List Devices");
    }

    if (DEBUG)println("Devices:\n");

    // Loop through devices
    for (int i=0;i<devs.length;i++)
    {
      if (DEBUG)
      {
        println(""+i+".\t"+devs[i]);
        println("---------------------------------------------\n");
      }

      // If this is our PIC Microcontroller
      try {
        if (devs[i].getProduct_id() == picNo &&
          devs[i].getVendor_id() == 1240)
        {     
          pic = devs[i].open();
          if (pic!=null) {
            pic.enableBlocking();
            picConnected = true;
            println("Opened "+pic.getProductString());
            readyToAsk = 1;
          }
        }
      } 
      catch (Exception e) {
        e.printStackTrace();
        if (DEBUG)println("Can't open PIC");
      }
    }
  }   

  usbEvent.start();
}

// USB Listener thread
USBListener usbEvent;
byte[] input_buffer = new byte[64];
byte[] output_buffer = new byte[65];
byte[] output_packet = new byte[100];
int[] rxBuffer = new int[8000];
int rxBufferIndex = 0;
int sendData = 0;
int iiusb = 0;
int numInPacket = 0;
int num = 0;
int got13 = 0;
int gotNewData = 0;
int j = 0;

private class USBListener extends Thread 
{
  public void run()
  {
    while (true)
    {
      if (picConnected) {
        try
        {
          int datalen=0;
          int i=0;

          if (sendData==1) {
            output_packet[1] = PApplet.parseByte(0); // start
            output_packet[2] = PApplet.parseByte((ToPic.PowerOn<<6&0x40)|(ToPic.SensA<<3&0x38)|(ToPic.SensB&0x07)); // PowerOn, SensA, SensB
            output_packet[3] = PApplet.parseByte(ToPic.NumDataPoints>>8&0xFF); // NumDataPoints high
            output_packet[4] = PApplet.parseByte(ToPic.NumDataPoints&0xFF); // NumDataPoints low
            
            output_packet[5] = PApplet.parseByte(ToPic.SampleRate>>8&0xFF); // SampleRate high
            output_packet[6] = PApplet.parseByte(ToPic.SampleRate&0xFF); // SampleRate low
            output_packet[7] = PApplet.parseByte(ToPic.FnType&0xFF); // FnType
            output_packet[8] = PApplet.parseByte(ToPic.FnFreq>>8&0xFF); // FnFreq high
            output_packet[9] = PApplet.parseByte(ToPic.FnFreq&0xFF); // FnFreq low
            output_packet[10] = PApplet.parseByte(ToPic.DigType&0xFF); // DigType
            output_packet[11] = PApplet.parseByte(ToPic.DigFreq>>8&0xFF); // DigFreq high
            output_packet[12] = PApplet.parseByte(ToPic.DigFreq&0xFF); // DigFreq low
            output_packet[13] = PApplet.parseByte(ToPic.TrigType&0xFF); // TrigType
            output_packet[14] = PApplet.parseByte(ToPic.TrigLevel&0xFF); // TrigLevel
            output_packet[15] = PApplet.parseByte(255); // end

            // doesn't matter what you put in index 0
            // index 1 later gets lenght of packet
            numInPacket = 2; 
            output_buffer[numInPacket] = PApplet.parseByte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = PApplet.parseByte(0); // start
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            for (iiusb=2;iiusb<15;iiusb++) {
              if (output_packet[iiusb]==13) {
                output_buffer[numInPacket] = 13;
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
              else {
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
            }
            output_buffer[numInPacket] = PApplet.parseByte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = PApplet.parseByte(255); // end
            //print(int(output_buffer[numInPacket]));
            //print(",   ");
            
            output_buffer[1] = PApplet.parseByte(numInPacket);
            output_buffer[0] = PApplet.parseByte(0);
            //println(numInPacket);

            pic.write(output_buffer); // warning - no check to make sure there are less than 64 bytes
            //println("Sent a message");
            sendData = 0;
            if (saveData1 == true) {
              saveData1 = false;
              ToPic.NumDataPoints = 0;
              saveData2 = true;
            }
          }

          pic.read(input_buffer);

          // The number of meaningful bytes is
          // stored in the zeroth byte
          datalen = (int)input_buffer[0]; // includes length          
          if (datalen > 0) {
            //println("Got a message!");
            //print("raw buff = ");
            //for(i=1;i<datalen;i++) {
            //  print(int(input_buffer[i]));
            //  print(" ");
            //}
            //println(" ");
            //got13 = 0;
            for (i=1;i<datalen;i++) {
              if(got13 == 1) {
                if(PApplet.parseInt(input_buffer[i]) == 0) {
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (PApplet.parseInt(input_buffer[i]) == 255) {
                  gotNewData = 1;
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (PApplet.parseInt(input_buffer[i]) == 13) {
                  rxBuffer[rxBufferIndex] = 13;
                  rxBufferIndex++;
                  got13 = 0;
                }
              }
              else if(PApplet.parseInt(input_buffer[i]) == 13) {
                got13 = 1;
              }
              else {
                rxBuffer[rxBufferIndex] = PApplet.parseInt(input_buffer[i]);
                rxBufferIndex++;
                got13 = 0;
              }
            }

            if (gotNewData == 1) {
              gotNewData = 0;
              //print("rx buff = ");
              //for(i=0;i<rxBufferIndex;i++) {
              //  print(rxBuffer[i]);
              //  print(',');
              //}
              //println(" ");
              
              ToPic.PowerOn = rxBuffer[0];
              //if(ToPic.PowerOn == 1) {
                //cbxPowerOn.setSelected(true);
              //}
              //else {
                //cbxPowerOn.setSelected(false);
              //}
              PowerUsage = (rxBuffer[1]<<8)+rxBuffer[2];
              //println(PowerUsage);
              DCount = (rxBuffer[3]<<8)+rxBuffer[4];
              DFreq = (rxBuffer[5]<<8)+rxBuffer[6];
              ToPic.gotNumDataPoints = (rxBuffer[7]<<8)+rxBuffer[8];
              
              if (ToPic.gotNumDataPoints == 1) {
                posY1 = rxBuffer[9+0*4]+((rxBuffer[11+0*4]&0x0C)<<6);
                posY2 = rxBuffer[10+0*4]+((rxBuffer[11+0*4]&0x03)<<8);
                //print(millis());
                //print (" ");
                //println(posY1);
              }
              
              /*
              if (ToPic.gotNumDataPoints < 750) {
                arrayCopy(dataA,ToPic.gotNumDataPoints,dataA,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataB,ToPic.gotNumDataPoints,dataB,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD1,ToPic.gotNumDataPoints,dataD1,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD2,ToPic.gotNumDataPoints,dataD2,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD3,ToPic.gotNumDataPoints,dataD3,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD4,ToPic.gotNumDataPoints,dataD4,0,750-ToPic.gotNumDataPoints);
                j = 0;
                for(i=750-ToPic.gotNumDataPoints;i<750;i++) {
                  dataA[i] = rxBuffer[9+j*4]+((rxBuffer[11+j*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[10+j*4]+((rxBuffer[11+j*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[12+j*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[12+j*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[12+j*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[12+j*4]&0x10)>>4)^1;
                  j++;
                }
                //dataIndex = 0;
              }
              else {
                for(i=dataIndex;i<ToPic.NumDataPoints+dataIndex;i++) {
                  dataA[i] = rxBuffer[9+i*4]+((rxBuffer[11+i*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[10+i*4]+((rxBuffer[11+i*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[12+i*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[12+i*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[12+i*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[12+i*4]&0x10)>>4)^1;
                }
                //dataIndex = dataIndex + ToPic.NumDataPoints;
              }
              */
              //if (dataIndex > 745) {
              //  dataIndex = 0;
              //}
              
              //if (stopAfterNextFill == 1) {
               // optFreeze.setSelected(true);
               // stopAfterNextFill = 0;
              //}
              
              readyToAsk = 1;
              sendData = 1;
              lastPacketTime = millis();
              
              //if (saveData2 == true) {
                //saveData2 = false;
                //textOutput = createWriter("positions.txt");
                //for (i=0;i<ToPic.gotNumDataPoints;i++) {
                  //textOutput.println(i);
                //}
                //textOutput.flush(); // Write the remaining data
                //textOutput.close(); // Finish the file
                //lblCountFreq.setText("Data saved!");
              //}
              /*
              print("PowerOn = ");
              println(ToPic.PowerOn);
              print("PowerUsage = ");
              println(PowerUsage);
              print("DCount = ");
              println(DCount);
              print("DFreq = ");
              println(DFreq);
              print("A = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataA[i]);
                print(" ");
              }
              println(" ");
              print("B = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataB[i]);
                print(" ");
              }
              println(" ");
              */
              //print("rxBufferIndex = ");
              //println(rxBufferIndex);
              /*
              print("D1 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD1[i]);
                print(" ");
              }
              println(" ");
              print("D2 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD2[i]);
                print(" ");
              }
              println(" ");
              print("D3 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD3[i]);
                print(" ");
              }
              println(" ");
              print("D4 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD4[i]);
                print(" ");
              }
              println(" ");
              */
            }
          }
        } 
        catch (Exception e) {
          if (picConnected) e.printStackTrace();
          println("Cannot Read From Device");
        }
      }
    }
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "NuScope3_5_pong" });
  }
}
